<?php

include './core.php';

checkAuth("CA");

cabecera (4);

$command = $_POST['command'];
$errorCode = "a0";

switch ($command) {

   // Primero mostraremos una clasificacion de las solicitudes segun su tipo
   // (CSR,RNR,CRR) con informacion sobre su estado actual, ademas de las 
   // acciones disponibles para cada una de ellas
   default:

      echo "<h1 class='title'>Gesti&oacute;n de solicitudes</h1>\n
            <p> En esta secci&oacute;n podr&aacute; realizar las siguientes operaciones: </p>
            <ul><li> Emitir Certificados </li>
            <li> Revocar Certificados </li> 
            <li> Aplazar Solicitudes </li>
            <li> Rechazar Solicitudes </li></ul>";                   

            echo "<form method='post' action='manage.php' enctype='multipart/form-data' name='sign_revoke_process'>\n";
 
            // Debemos hacer tres busquedas en el ldap: las CRRs,CSRs y RNRs
	    while (list($requestType) = each($caManageActions)) {
               // Cuando $requestType sea igual a crr, construimos un filtro 
               // para la busqueda de las solicitudes de revocacion pendientes 
               // y las aplazadas 
               if ($requestType == "crr") {
                  echo "<h2>CRRs Pendientes</h2>";
                  $filter = "(|(pkirisStatus=crr-pending)(pkirisStatus=crr-deferred))";                 
               }
               // Cuando sea igual a csr, buscaremos las CSRs
               else if ($requestType == "csr") {
                  echo "<h2>CSRs Pendientes</h2>";
                  $filter = "(|(pkirisStatus=csr-pending)(pkirisStatus=csr-deferred))";
               }
               // En este caso mostramos las solicitudes de renovacion
               else if ($requestType == "rnr") {
                  echo "<h2>RNRs Pendientes</h2>";
                  $filter = "(|(pkirisStatus=rnr-pending)(pkirisStatus=rnr-deferred))";
               }

               // Solo nos traeremos los atributos necesarios
               $justthese = array("pkiriscopaid", "pkirisid", "pkirisdate", "pkirisstatus");
               $result = ldap_get_info ($ldapVar['base'], $filter, $justthese); 
               if ( !$result )
                  $errorCode = "a3b1c1d1";
               else if ( $result['count'] == 0 ) 
                  echo "<p>No hay ninguna solicitud pendiente de este tipo</p>";
               else{
                  echo "<table border='0' cellpadding='0' cellspacing='0'>
                    <tr>
                      <th class='header'>C&oacute;digo</th>
                      <th class='header'>Identificador</th>
                      <th class='header'>Fecha</th>
                      <th class='header'>Estado</th>
                      <th class='header'>Comentario</th>
                      <th class='header'>Acci&oacute;n</th>
                    </tr>";

                  // Recorremos todas las solicitudes del tipo $requestType 
                  for ($reqsCounter = 0; $reqsCounter < $result['count']; $reqsCounter ++) {

                     $copaId = $result [$reqsCounter]["pkiriscopaid"][0];
                     $reqDateTmp = $result [$reqsCounter]["pkirisdate"][0];
                     $ident = $result [$reqsCounter]["pkirisid"][0];
                     $status = $result [$reqsCounter]["pkirisstatus"][0];
                    
                     $year = substr("$reqDateTmp", 0, 4);
           	     $month = substr("$reqDateTmp", 4, 2);
           	     $day = substr("$reqDateTmp", 6, 2);
           	     $hour = substr("$reqDateTmp", 8, 2);
                     $minute = substr("$reqDateTmp", 10, 2);
                     $seconds = substr("$reqDateTmp", 12, 2);
                     $reqDate = $day."/".$month."/".$year." - ".$hour.":".$minute.":".$seconds;
                    
                     // Obtenemos el ultimo comentario de la solicitud 
                     $lastComment = getLastComment($copaId);
	             if ( false ) //!$lastComment )
                        $errorCode = "a3b1c2d1";
                     else {
                        // Direferenciamos las solicitudes pares de las impares
                        // para mostrarlas cada una de un tono de gris diferente
                        if ($reqsCounter==0) {
                          echo "<tr>
                            <td class='even'>$copaId</td>
                            <td class='even'>$ident</td>
                            <td class='even'>$reqDate</td>
                            <td class='even'>$status</td>
                            <td class='even'><input type='text' name='comments[$copaId]' size='15' value='$lastComment'</td>
                            <td class='even'><select name='actions[$requestType][$copaId]'>";
                              while (list($index) = each($caManageActions[$requestType])) 
                                echo "<option>$index</option>";
                              echo "</select>
                            </td>
                          </tr>";
                        }
                        else {
                          echo "<tr>
                            <td class='odd'>$copaId</td>
                            <td class='odd'>$ident</td>
                            <td class='odd'>$reqDate</td>
                            <td class='odd'>$status</td>
                            <td class='odd'><input type='text' name='comments[$copaId]' size='15' value='$lastComment'</td>
                            <td class='odd'><select name='actions[$requestType][$copaId]'>";
                              while (list($index) = each($caManageActions[$requestType]))
                                echo "<option>$index</option>";
                              echo "</select>
                            </td>
                          </tr>";
                        }

                        // Para que apunte de nuevo al primer elemento, reseteamos
                        // el puntero de la matriz $caManageActions[$requestType]
                        reset($caManageActions[$requestType]);
                     }
                  }
                  echo "</table>\n";
               } 
            }
            echo "<input type='hidden' name='command' value='request_prosecute' />


        <div id='tbox'>
        <h3 class='head_a2b1'>Autenticaci&oacute;n</h3>
        <div id='tbox_data_a1'>
          <div id='trow'>

            <div id='tname'>Pass Phrase:</div>
            <div id='tvalue'><input type='password' name='passPhrase' size='35'></div>
          </div>
          <div id='trow'>
            <div id='tvalue'><input class='button' type='submit' value='Procesar' /></div>
          </div>
        </div>
      </div>

            </form>\n";

      break;

   // En esta seccion ejecutaremos las acciones escogidas para cada solicitud
   // en la seccion anterior
   case "request_prosecute":

      $comments = $_POST['comments'];
      $actions = $_POST['actions'];
      $passPhrase = $_POST['passPhrase'];
      // En este array guardaremos los codigos copa de todas las solicitudes
      // que se vayan a exportar a la RA en un fichero XML
      $copasArray = array();
      // Recorremos todas las solicitudes del tipo $requestType
      while (list($requestType) = each($caManageActions)) {
         // Comprobamos que exista almenos una solicitud del tipo $requestType
         if ( count($actions[$requestType]) != 0) { 
            while (list($copa,$requestAction) = each($actions[$requestType])) {
               $dn = $ldapVar['rdnAttr']."=$copa,".$ldapVar['base'];
               $currentDate = date ("YmdHis");
               $invalidityDate = $currentDate;
               $subjString = '';
               // Inicializamos la traza a null. Esto se hace para evitar 
               // insertar la traza de una solicitud anterior en caso de que 
               // no se haya generado una traza nueva (ocurre al aplazar)
               $newTrace = null;

               // Nos traemos del ldap el identificador de la 
               // solicitud/certificado
               $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
               $justthese = array ("pkirisid");
               $info = ldap_get_info($dn,$filter,$justthese);
               if ( !$info )
                  $errorCode = "a3b1c1d1";
               else {     
                  $requestId = $info[0]["pkirisid"][0];

                  switch ($requestAction) {
                     case "Revocar":
                        echo "Revocando la solicitud con n&uacute;mero copa = $copa. <br>";
                 
                        // Nos traemos del ldap el motivo de revocacion y el
                        // codigo copa del usuario que revoco el certificado
                        $filter2 = "(&(objectClass=pkirisCertificate)(pkirisCopaID=$copa))";
                        $justthese2 = array ("pkirisrevocationreason", "pkirisrevokedbycopaid");
                        $result = ldap_get_info($dn,$filter2,$justthese2);
                        if ( !$result )
                           $errorCode = "a3b1c1d1";
                        else {
                           $revReason = $result[0]['pkirisrevocationreason'][0];
                           $revokedBy = $result[0]['pkirisrevokedbycopaid'][0]; 
      
                           // Si el codigo copa del que realizo la crr coincide con el numero copa del
                           // usuario del certificado es porque la peticion la hace el propio usuario
                           list($usrCopa, $k) = split("c", $copa);
                           if ($revokedBy == $usrCopa)
                              $status = $caManageActions[$requestType][$requestAction] . "usr";
                           // En caso contrario, la peticion la realizo algun administrador de la RA
                           else
                              $status = $caManageActions[$requestType][$requestAction] . "ra";
                 
                           $r = revoke($copa, $status, $passPhrase);
                           if ( !$r )
                              $errorCode = "a3b1c2d2";
                           else {
                              // Preparamos los datos para crear la traza
                              $traceVals ["status"] = $status;
                              $traceVals ["copa"] = $copa;
                              $traceVals ["currentDate"] = $currentDate;
                              $traceVals ["invalidityDate"] = $invalidityDate;
                              $traceVals ["revocationReason"] = $revReason;

                              // Generamos la traza con los valores de $traceVals. No la
                              // insertaremos en el ldap hasta que no se hayan actualizado
                              // de forma correcta sus atributos
                              $newTrace = getTrace($traceVals);
                              if ( !$newTrace )
                                 $errorCode = "a3b1c2d4";
                              else {
                                 // Metemos en el array '$copasArray' el numero copa de
                                 // la solicitud actual para incluirla en el fichero XML
                                 $r = array_push($copasArray, $copa); 
                              }
                           }
                        }
                      
                     break;

                     case "Firmar":
                        echo "Firmando la solicitud con n&uacute;mero copa = $copa. <br>";

                        $status = $caManageActions[$requestType][$requestAction];
                        $r = sign($copa, $status, $passPhrase);
                        if ( !$r )
                           $errorCode = "a3b1c2d3";
                        else {
                           // Necesitamos pasar el certificado a dos formatos 
                           // diferentes para insertarlo en el ldap y para 
                           // sacarle la fecha de expiracion:
                          
                           // Formato para el LDAP: 
                           
                             // Leemos el certificado .der y lo pasamos a una cadena
                             $file = $dirVar['crt'] . $copa . ".der";
                             $certFile = fopen($file, "r");
                             if ( !$certFile )
                                $errorCode = "a3b1c2d5";
         		     else {
                                $ldapCertString = "";

                                while (!feof($certFile)) {
                                   $buf = fgets($certFile, 4096);
                                   if ( !$buf )
                                      $errorCode = "a3b1c2d6";
                                   else 
                                      $ldapCertString = $ldapCertString . $buf;
                                }                           
			     }
                             $r = fclose($certFile);
                             if ( !$r )
                                $errorCode = "a3b1c2d7";
                         
                             if ( $errorCode = "a0" ) {  
                              // Formato para obtener la fecha de expiracion: //

                                // Para obtener la fecha de expiracion del certificado, 
                                // parseamos el certificado y lo pasamos a un array
                                $pemCertificate = file_get_contents($dirVar['crt']."$copa.pem");
                                $arrayCert = openssl_x509_parse($pemCertificate);
                    
                                // Pasamos la fecha al formato de la pkiris 
                                list ($expirationDate, $k) = split("Z", $arrayCert['validTo']);
                                $expirationDate = "20" . $expirationDate;
                   
                                // En este array guardaremos los valores de los atributos que 
                                // se modificaran en el ldap. Se completa mas adelante
                                $updateFields["userCertificate;binary"] = $ldapCertString;
                                $updateFields["pkiriscertificateexpirationdate"] = $expirationDate;

                                // Preparamos los datos para crear la traza
                                $traceVals ["status"] = $status;
                                $traceVals ["copa"] = $copa;
                                $traceVals ["currentDate"] = $currentDate;
 
                                // Generamos la traza con los valores de $traceVals. No la
                                // insertaremos en el ldap hasta que no se hayan actualizado
                                // de forma correcta sus atributos
                                $newTrace = getTrace($traceVals);
                                if ( !$newTrace )
                                   $errorCode = "a3b1c2d4";
                                else {
                                   // Metemos en el array '$copasArray' el numero copa de
                                   // la solicitud actual para incluirla en el fichero XML
                                   $r = array_push($copasArray,$copa);                           
                                }
                             } 
                        }                                  
                     break;
             
                     case "Aplazar":
                        echo "Aplazando la solicitud con n&uacute;mero copa = $copa. <br>";

                        $status = $caManageActions[$requestType][$requestAction];
                        $lastStatus = getStatus($copa);
                        if ( !$lastStatus ) 
                           $errorCode = "a3b1c2d8";
                        else {                      
                           $lastComment = getLastComment($copa);
                           if ( false ) // !$lastComment ) // Arreglar funcion para que 
                                                           // no devuelva false si la traza no tiene comentarios
                              $errorCode = "a3b1c2d1";
                           else {
                              // Comprobamos si estamos en un estado valido 
                              if ( (strstr($lastStatus,"-pending") || strstr($lastStatus,"-deferred")) && ($lastStatus != $status) ) {
                                 // Ademas, si el estado anterior fue "Aplazado", debemos
                                 // comprobar que ha cambiado el comentario para no volver
                                 // a escribir la misma traza
                                 if ( ( !strstr($status,"-deferred") ) || ($lastComment != $comments[$copa])) { 
                                    // Preparamos los datos para crear la traza
                                    $traceVals ["status"] = $status;
                                    $traceVals ["copa"] = $copa;
                                    $traceVals ["currentDate"] = $currentDate;
                                    $traceVals ["comments"] = $comments[$copa];
                          
                                    // Generamos la traza con los valores de $traceVals. No la
                                    // insertaremos en el ldap hasta que no se hayan actualizado
                                    // de forma correcta sus atributos
                                    $newTrace = getTrace($traceVals);
                                 }
                              }
                              else 
                                 $errorCode = "a3b1c2d9";
                           }
                        }
                  
                     break;

                     case "Rechazar":
                        echo "Rechazando la solicitud con n&uacute;mero copa = $copa. <br>";
                    
                        $status = $caManageActions[$requestType][$requestAction];
                        $lastStatus = getStatus($copa);
                        if ( !$lastStatus )
                           $errorCode = "a3b1c2d8";
                     
                        // Comprobamos si estamos en un estado valido
                        else if ( (strstr($lastStatus,"-deferred") || strstr($lastStatus,"-pending") || strstr($lastStatus,"-deferred")) && ($lastStatus != $status) ) {
                           // Preparamos los datos para crear la traza
                           $traceVals ["status"] = $status;
                           $traceVals ["copa"] = $copa;
                           $traceVals ["currentDate"] = $currentDate;
                           $traceVals ["comments"] = $comments[$copa];

                           // Generamos la traza con los valores de $traceVals. No la
                           // insertaremos en el ldap hasta que no se hayan actualizado
                           // de forma correcta sus atributos
                           $newTrace = getTrace($traceVals);
                           if ( !$newTrace )
                              $errorCode = "a3b1c2d4";
                           else {
                              // Metemos en el array '$copasArray' el numero copa de
                              // la solicitud actual para incluirla en el fichero XML                   
                              $r = array_push($copasArray,$copa);
                           }
                        } 
                        else 
                           $errorCode = "a3b1c2d9";

                     break;   
                  }

                  ////////////////////////////////////////////////////////////////
                  // Ya hemos obtenido toda la informacion para actualizar el ldap
                  // en caso de que no haya habido errores
                  ////////////////////////////////////////////////////////////////
 
                  if ( $errorCode == "a0" && $newTrace != null ) {
                     // Modificamos la el estado y la fecha del certificado en el ldap
                     $updateFields["pkirisstatus"] = $status;
                     $updateFields["pkirisdate"] = $currentDate;             
                  
                     $r = ldap_mod_info ($dn, $updateFields);
                     if (!$r) 
                        $errorCode = "a3b1c1d2";
                     // Modificamos el atributo pkirisTrace para agregar la traza
                     // firmada
                     else {
                        $urn["pkiristrace"] = $newTrace;
                        $r = ldap_mod_add_info($dn, $urn);
                        if (!$r) 
                           $errorCode = "a3b1c1d3";
                        else {
                           // Escribimos en el fichero de log los cambios de estado realizados
                           $pkiLog['status'] = $status;
                           $pkiLog['eee'] = $copa;
                           $pkiLog['user'] = "CA-Admin";
                           $pkiLog['error'] = $errorCode;
                           writeLog ($pkiLog);
                        }
                     }
                  }
               }
            }                 
         }
      }
     // Si no ha habido ningun error y hay al menos una solicitud para
     // exportar, creamos el fichero XML
     if ( $errorCode == 0 && count($copasArray) > 0 ) {
        // Generamos el fichero XML de las solicitudes indicadas por el
        // array 'copasArray'
        $r = createXML ($copasArray);
        if (!$r) 
           $errorCode = "a3b1c2d10";
        else 
           echo "<p>La gesti&oacute;n de las solicitudes se ha realizado con &eacute;xito.</p>\n";
     }
   break;
}

// Si se ha producido algun error, llamamos a la funcion encargada de
// tratarlos
if ( $errorCode != "a0" ) {
   echo "<h3>Error en la gesti&oacute;n de las solicitudes.\n</h3>";

   $pkiLog['status'] = "manage";
   $pkiLog['eee'] = "none";
   $pkiLog['user'] = "CA-Admin";
   $pkiLog['error'] = $errorCode;
   pkirisErrorHandler($pkiLog);
}

pie ();

?>


